<template>
  <div class="d-flex flex-column">
    <div class="d-flex flex-column">
      <div v-if="loading" class="card-top d-flex flex-column">
        <div class="d-flex justify-center">
          <v-img v-if="imgPath" :src="media + imgPath" :aspect-ratio="1" class="img" cover />
          <img v-else src="/assets/image/non-equipment.jpg" :aspect-ratio="1" class="img" cover />
        </div>
      </div>
      <div v-if="loading" class="d-flex flex-column card-text">
        <p class="text-name">{{ equipmentName }}</p>
      </div>
      <div v-if="loading" class="d-flex flex-column card-text">
        <p class="text-title">รายละเอียด</p>
        <p v-if="detail">{{ detail }}</p>
        <p v-else> - </p>
      </div>
      <div v-if="loading" class="d-flex flex-column card-text">
        <div class="d-flex">
          <p>จำนวนคงเหลือ</p>
          <p v-if="quantity > 0">{{ quantity }}</p>
          <p v-else>หมดแล้ว</p>
        </div>
        <div class="d-flex">
          <p>ระยะเวลาในการยืม</p>
          <p>{{ dayLimit }} วัน</p>
        </div>

        <div class="d-flex">
          <p>กำหนดการคืน</p>
          <p class="text-amber-400">{{ returnSchedule }}</p>
        </div>
      </div>
      <div v-if="loading" class="d-flex flex-column card-text py-2">
        <div class="d-flex">
          <p>จาก</p>
          <p>{{ serviceProvider }}</p>
        </div>
      </div>
      <br>
      <div v-if="loading" class="card-text d-flex justify-space-around">
        <v-btn @click="onAddEquipmentToBasket(equipmentId)" rounded="lg" width="150" variant="flat" class="text-black">
          <p>เพิ่มลงในตะกร้า</p>
        </v-btn>
        <nuxt-link v-if="quantity > 0" :to="`/borrowing-confirmation/${equipmentId}`" class="link">
          <v-btn rounded="lg" width="150" variant="flat" color="#fcc200">
            <p>ยืม</p>
          </v-btn>
        </nuxt-link>
        <v-btn v-else rounded="lg" width="150" variant="flat" color="#fcc200" disabled>
          <p>ยืม</p>
        </v-btn>
      </div>

      <div v-if="!loading" class="card d-flex flex-column mb-2">
        <v-skeleton-loader type="card"></v-skeleton-loader>
      </div>
      <div v-if="!loading" class="text-detail mb-2">
        <v-skeleton-loader type="list-item-two-line"></v-skeleton-loader>
      </div>
      <div v-if="!loading" class="text-detail mb-2">
        <v-skeleton-loader type="paragraph"></v-skeleton-loader>
      </div>
      <div v-if="!loading" class="text-detail mb-2">
        <v-skeleton-loader type="list-item-two-line"></v-skeleton-loader>
      </div>

      <v-col cols="auto">
        <v-dialog v-model="addSuccess" max-width="250">
          <template v-slot:default>
            <v-card rounded="xl">
              <div class="pb-5 text-center">
                <v-icon class="my-6" color="success" icon="mdi-check-circle-outline" size="128"></v-icon>
                <div class="text-h5 font-weight-bold">เพิ่มอุปกรณ์เรียบร้อย</div>
              </div>
            </v-card>
          </template>
        </v-dialog>
      </v-col>
    </div>
  </div>
</template>

<script setup>
useHead({
  title: "ระบบยืม-คืน | รายละเอียดอุปกรณ์",
  meta: [{ name: "description", content: "รายละเอียดอุปกรณ์" }],
});
definePageMeta({
  middleware: "auth",
});

import { ref, onMounted } from "vue";
import axios from "axios";

const token = useStrapiToken();
const url = useStrapiUrl();
const media = useStrapiMedia();

const equipment = ref();
const equipmentId = ref();
const equipmentName = ref();
const detail = ref();
const dayLimit = ref();
const quantity = ref();
const serviceProvider = ref();
const imgPath = ref();
const returnSchedule = ref();

const loading = ref(false)
const addSuccess = ref(false)

async function getEquipmentsFindOne() {
  loading.value = true
  try {
    const { id } = useRoute().params;
    await axios
      .get(`${url}/equipments/${id}`, {
        params: {
          populate: {
            image: {
              fields: {
                0: "url",
              },
            },
          },
        },
        headers: {
          Authorization: `Bearer ${token.value}`,
        },
      })
      .then((response) => {
        equipment.value = response.data.data;
        equipmentName.value = equipment.value.attributes.name
        equipmentId.value = equipment.value.id
        if (equipment.value.attributes.image.data != null) {
          imgPath.value = equipment.value.attributes.image.data[0].attributes.url;
        }
        detail.value = equipment.value.attributes.detail
        dayLimit.value = equipment.value.attributes.day_limit
        quantity.value = equipment.value.attributes.quantity
        serviceProvider.value = equipment.value.attributes.provider_name
        getReturnSchedule();
      });
  } catch (error) {
    console.log(error);
  } finally {
    loading.value = true
  }
}

async function getReturnSchedule() {
  const today = new Date();
  const returnDate = new Date(today.setDate(today.getDate() + dayLimit.value));
  const thaiDate = returnDate.toLocaleDateString('th-TH', {
    day: 'numeric',
    month: 'long',
    year: 'numeric'
  });
  returnSchedule.value = thaiDate

  return returnDate;
}

async function onAddEquipmentToBasket(equipmentId) {
  try {
    const user = await useStrapiUser()
    await axios.put(`${url}/users/${user.value.id}`, {
      basket: {
        connect: [equipmentId]
      }
    }, {
      headers: {
        Authorization: `Bearer ${token.value}`,
      }
    })
    console.log("เพิ่มอุปกรณ์เรียบร้อย")
    addSuccess.value = true
    setTimeout(() => (addSuccess.value = false), 1000);
  } catch (error) {
    console.log("ไม่สามารถเพิ่มอุปกรณ์ลงในรถเข็นได้")
  }
}

onMounted(async () => {
  await getEquipmentsFindOne();
});
</script>

<style scoped>
.container {
  display: flex;
  justify-content: center;
}

.card-top {
  background-color: #ffffff;
  border-radius: 5px;
  margin-bottom: 5px;
}

.img {
  max-width: 400px;
  margin: 20px 0;
  border-radius: 5px;
  box-shadow: 0 5px 10px rgba(0, 0, 0, 0.05);
}

.text-name {
  font-size: 20px;
  padding: 10px;
}

.card-text {
  border-radius: 5px;
  background-color: white;
  margin-bottom: 5px;
  padding: 5px 10px;
}

.text-title {
  font-size: 18px;
}

.link {
  text-decoration: none;
  color: black;
}

.link p {
  font-size: 16px;
}

p {
  font-size: 16px;
  width: 100%;
  padding: 3px;
}
</style>
